import { Meta, Preview, Props, Story } from '@storybook/addon-docs/blocks';
import { DependenciesTable } from 'storybook-addon-deps/blocks';
import { withKnobs, boolean, object } from '@storybook/addon-knobs';

import ASimpleNavbarUi from './ASimpleNavbarUi.vue';

<Meta
  title="Core/Organisms/ASimpleNavbarUi"
  component={ASimpleNavbarUi}
  parameters={{ component: ASimpleNavbarUi }}
/>

# A-Simple-Navbar-Ui

A simple navbar with left and right placeholder areas.

<Preview columns={1}>
  <Story name="default" decorators={[withKnobs]}>
    {{
      components: { ASimpleNavbarUi },
      props: {
        full: { default: boolean('full', true, 'Props') },
        styles: {
          default: () =>
            object(
              'CSS Variables',
              {
                '--a-simple-navbar-ui--h': '4rem',
                '--a-simple-navbar-ui--text-color': 'inherit',
                '--a-simple-navbar-ui--bg-color': '#f9fafb',
              },
              'Styles'
            ),
        },
      },
      template: `
        <a-simple-navbar-ui :full="full" :style="styles">
          <template #navbar-start>
            <a-box-l class="reset flex items-center p-4 bg-gray-200">
              <span>Navbar Start</span>
            </a-box-l>
          </template>
          <template #navbar-end>
            <a-box-l class="reset flex items-center p-4 bg-gray-200">
              <span>Navbar End</span>
            </a-box-l>
          </template>
        </a-simple-navbar-ui>
      `,
    }}
  </Story>
  <Story name="with-logo">
    {{
      components: { ASimpleNavbarUi },
      template: `
        <a-simple-navbar-ui full>
          <template #navbar-start>
            <div class="flex items-center">
              <img
                class="block h-6 w-auto"
                src="https://nuxtjs.org/logos/built-with-nuxt.svg"
                alt="Nuxt.js logo"
              />
            </div>
          </template>
        </a-simple-navbar-ui>
      `,
    }}
  </Story>
  <Story name="with-avatar">
    {{
      components: { ASimpleNavbarUi },
      template: `
        <a-simple-navbar-ui full>
          <template #navbar-start>
            <div class="flex items-center">
              <img
                class="block h-6 w-auto"
                src="https://nuxtjs.org/logos/built-with-nuxt.svg"
                alt="Nuxt.js logo"
              />
            </div>
          </template>
          <template #navbar-end>
            <div class="flex items-center">
              <img
                class="block h-10 w-10 rounded-full"
                src='https://secure.gravatar.com/avatar/f925124b0eed1eeab8513016914b9150?s=117&d=identicon'
                alt="User avatar"
              />
            </div>
          </template>
        </a-simple-navbar-ui>
      `,
    }}
  </Story>
  <Story name="with-menu">
    {{
      components: { ASimpleNavbarUi },
      template: `
        <a-simple-navbar-ui full>
          <template #navbar-start>
            <div class="flex items-center">
              <img
                class="block h-6 w-auto"
                src="https://nuxtjs.org/logos/built-with-nuxt.svg"
                alt="Nuxt.js logo"
              />
            </div>
          </template>
          <template #navbar-end>
            <a-cluster-l :style="{ '--a-cluster-l--align': 'stretch', '--a-cluster-l--space': '0' }">
              <ul class="h-full space-x-6">
                <li class="inline-flex items-center border-b-2 border-indigo-500 text-sm font-medium leading-5 text-gray-900">
                  <a href="#">Services</a>
                </li>
                <li class="inline-flex items-center border-b-2 border-transparent text-sm font-medium leading-5 text-gray-500 hover:text-gray-700 hover:border-gray-300">
                  <a href="#">Portfolio</a>
                </li>
                <li class="inline-flex items-center border-b-2 border-transparent text-sm font-medium leading-5 text-gray-500 hover:text-gray-700 hover:border-gray-300">
                  <a href="#">About</a>
                </li>
                <li class="inline-flex items-center border-b-2 border-transparent text-sm font-medium leading-5 text-gray-500 hover:text-gray-700 hover:border-gray-300">
                  <a href="#">Contact</a>
                </li>
              </ul>
            </a-cluster-l>
          </template>
        </a-simple-navbar-ui>
      `,
    }}
  </Story>
</Preview>

## API

<Props of={ASimpleNavbarUi} />

## Installation

```bash
yarn add -E @bit/adakode.ak-ui.core.organisms.a-simple-navbar
```

Install the component layout dependency:

```bash
yarn add -E @bit/adakode.ak-ui.core.layouts.a-box
```

## Usage

```html
<!-- Custom Navbar: constrained logo and menu -->
<a-simple-navbar-ui>
  <template #navbar-start>
    <div class="flex items-center">
      <brand-logo class="block h-6 w-auto" alt="Brand logo" />
    </div>
  </template>
  <template #navbar-end>
    <a-cluster-l
      :style="{ '--a-cluster-l--align': 'stretch', '--a-cluster-l--space': '0' }"
    >
      <ul class="h-full space-x-6">
        <li class="inline-flex items-center border-b-2 border-indigo-500 ...">
          <a-link-ui>Dashboard</a-link-ui>
        </li>
        <li class="inline-flex items-center border-b-2 border-transparent ...">
          <a-link-ui>Team</a-link-ui>
        </li>
        <li class="inline-flex items-center border-b-2 border-transparent ...">
          <a-link-ui>Projects</a-link-ui>
        </li>
        <li class="inline-flex items-center border-b-2 border-transparent ...">
          <a-link-ui>Calendar</a-link-ui>
        </li>
      </ul>
    </a-cluster-l>
  </template>
</a-simple-navbar-ui>
```

## Customization

There are several ways to customize the look and feel of the component,
depending on the desired scope of the customization.

### Global Customization

To customize the look and feel of **every single instance** of the component
create a css file defining a class named after the kebab-case version of the component name
and define any of the custom properties below:

| CSS variable                       |   default | design token              |
| :--------------------------------- | --------: | :------------------------ |
| `--a-simple-navbar-ui--h`          |    `4rem` | `theme('spacing.16')`     |
| `--a-simple-navbar-ui--text-color` | `inherit` | `n/a`                     |
| `--a-simple-navbar-ui--bg-color`   | `#f9fafb` | `theme('colors.gray.50')` |

These are the steps:

```bash
mkdir -p src/assets/styles/components/ui/core/organisms && touch $_/ASimpleNavbarUi.css
```

```css
/* <rootDir>/src/assets/styles/components/index.css */
@import './ui/core/organisms/ASimpleNavbarUi.css';
```

```css
/* <rootDir>/src/assets/styles/components/ui/core/organisms/ASimpleNavbarUi.css */
.a-simple-navbar-ui {
  --a-simple-navbar-ui--h: theme('spacing.16');
  --a-simple-navbar-ui--text-color: inherit;
  --a-simple-navbar-ui--bg-color: theme('colors.gray.50');
}
```

### Scoped Customization

To customize the look and feel of a **group of instances** of the component
augment the specificity of the component class with a scoping class:

```css
/* <rootDir>/src/assets/styles/components/ui/core/organisms/ASimpleNavbarUi.css */
.a-simple-navbar-ui.a-simple-navbar-ui--dark {
  --a-simple-navbar-ui--text-color: theme('colors.gray.50');
  --a-simple-navbar-ui--bg-color: theme('colors.gray.800');
}
.a-simple-navbar-ui.a-simple-navbar-ui--light {
  --a-simple-navbar-ui--text-color: theme('colors.gray.800');
  --a-simple-navbar-ui--bg-color: theme('colors.gray.50');
}
```

```html
<!-- <rootDir>/src/components/path/to/the/ConsumerComponent.vue -->
<a-simple-navbar-ui
  :class="prefersDark ? 'a-simple-navbar-ui--dark' ? 'a-simple-navbar-ui--light'"
>
  <template #navbar-start>
    <div class="flex items-center">
      <brand-logo class="block h-6 w-auto" alt="Brand logo" />
    </div>
  </template>
</a-simple-navbar-ui>
```

### Instance Customization

To customize the look and feel of a **single instance** of the component
you can define the desired CSS variables inline:

```html
<!-- Using CSS variables -->
<a-simple-navbar-ui
  :style="{
    '--a-simple-navbar-ui--h': '4rem',
    '--a-simple-navbar-ui--text-color': 'inherit',
    '--a-simple-navbar-ui--bg-color': '#f9fafb',
  }"
>
  <template #navbar-start>
    <div class="flex items-center">
      <brand-logo class="block h-6 w-auto" alt="Brand logo" />
    </div>
  </template>
</a-simple-navbar-ui>
```

## Dependencies

<DependenciesTable
  titleDependencies="Dependencies"
  titleDependents="Dependents"
  of={ASimpleNavbarUi}
/>

## Links

Source: https://gitlab.com/adakodecoop/coop/adakode-ui/-/tree/master/src/components/ui/core/organisms/ASimpleNavbar  
Bit: https://bit.dev/adakode/ak-ui/core/organisms/a-simple-navbar
